Skip to main content Skip to footer
x

Exciting news! We are now MESCIUS USA, Inc. Read More!

We are now MESCIUS USA, Inc. Read More!

We are now MESCIUS USA!

How to Add a JavaScript Pivot Table to Your Web Application

  • 0 Comments
Quick Start Guide
Tutorial Concept

Learn how to integrate a JavaScript spreadsheet component with Pivot Table functionality in JS web applications.

What You Will Need

Visual Studio Code
SpreadJS and the PivotTable Add-On
NPM Packages:

Controls Referenced

SpreadJS JavaScript Pivot Table Add-On
Online Demo Explorer | Documentation

Pivot Tables are undeniably one of the most powerful data analysis tools; they help organize data so users can detect recurring patterns more easily. Pivot Tables help users create customized tables from large data groups. Using pivot functionalities, the user can summarize, sort, reorganize, group, count, total, or average data effortlessly within a table.

SpreadJS, a JavaScript spreadsheet component, has an optional Pivot Tables add-on feature that allows JavaScript developers to create Excel-like Pivot Tables programmatically in their applications or allow end-users to create them easily with a familiar UI.

>> Explore our online JavaScript Pivot Table demo to start using SpreadJS’ PivotTables <<

Ready to Get Started? Download a free trial of SpreadJS today!

This blog will go through some of the essential properties and features of the JavaScript spreadsheet Pivot Table API that will help you customize the appearance of your pivot tables and reports derived from these Pivot Tables.

Customizing Pivot Tables and Reports with the JavaScript Spreadsheet Pivot Table API

>> You can download a sample application to follow along with the blog <<

Create a JavaScript Pivot Table

Imagine having countless rows of data containing specific information. For example, in the datasheet below, we have a large number of records showing the best-selling video games.

JavaScript Spreadsheet Pivot Table Data

The goal is to create a report summarizing this raw data into more insightful information. The below function shows how to programmatically add a pivot table and add fields in a JavaScript application using SpreadJS’ PivotTable class API.

function initPivotTable(sheet, tableName) {
    sheet.name("Basic PivotTable");
    let pivotTableOptions = {bandRows:true,bandColumns:true};
    // Create Pivot Table
    let pivotTable = sheet.pivotTables.add("PivotTable", tableName, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.tabular, GC.Spread.Pivot.PivotTableThemes.medium14, pivotTableOptions);
    pivotTable.suspendLayout();
    pivotTable.add("Genre", "Genre", GC.Spread.Pivot.PivotTableFieldType.rowField);
    pivotTable.add("Name", "Name", GC.Spread.Pivot.PivotTableFieldType.rowField);
    pivotTable.add("NA_Sales", "NA_Sales", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
    pivotTable.add("EU_Sales", "EU_Sales", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
    pivotTable.add("JP_Sales", "JP_Sales", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
    pivotTable.add("Other_Sales", "Other_Sales", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
    pivotTable.add("Global_Sales", "Global_Sales", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
    pivotTable.resumeLayout();
}
After applying this code, the PivotTable will display in the JavaScript application like so:
JavaScript Pivot Table

Another way of creating a pivot table is by using the Pivot Panel offered by SpreadJS. To initialize the Pivot Panel, first, create a DOM element in the HTML file, in this case, a DIV with an ID “panel”:

<body>
    <div class="sample-tutorial">
        <div id="ss" class="sample-spreadsheets"></div>
        <div class="sample-panel">
            <div id="panel"></div>
        </div>
    </div>
</body>

Apply CSS for the side panel in the styles.css file. Interesting side note - developers can customize the styling and appearance of the Pivot Panel here through the CSS:

.sample-panel {
  float: right;
  width: 300px;
  padding: 12px;
  height: 100%;
  box-sizing: border-box;
  background: #fbfbfb;
  overflow: auto;
}
.gc-panel {
  padding: 10px;
  background-color: rgb(230, 230, 230);
}
#panel {
  position: absolute;
  right: 0;
  width: 300px;
  height: 100%;
  top: 0;
}

Then, use SpreadJS’ PivotPanel constructor to initialize the panel:

var panel = new GC.Spread.Pivot.PivotPanel("myPivotPanel", myPivotTable, document.getElementById("panel"));

The application will now display the SpreadJS PivotTable with the side panel, allowing end-users to drag and drop needed fields according to the report logic.

JavaScript Pivot Table


Pivot Layout

SpreadJS allows you to choose from three different pivot table layouts to offer different visualizations of your data. This includes the Compact, Outline, and Tabular form layouts. By default, the pivot table layout is Compact form. Still, users can set the layout when creating the pivot table using the PivotTable constructor or change the layout using the layoutType function. The function has an integer argument corresponding to the form layout (0 - compact, 1 - outline, 2 - tabular).

// Set an outline form (1)
pivotTable.layoutType(1);

Compact Form (0)

This layout contains all the Row fields in one column in a hierarchical structure.

This layout form optimizes readability by keeping related data in one column. Still, if you copy and paste the data into a new worksheet, it will be harder to do further analysis.

JavaScript Pivot Table

Outline Form (1)

This layout has a hierarchical structure, but each Row field is in a separate column in the pivot table. It displays one column per field and provides space for field headers.

Using this form, you can include Field headers in each column, repeat all item labels, and reuse the data of the Pivot Table in a new location for further analysis. Still, this form uses horizontal space, so it might not be beneficial to use it in some cases.

JavaScript Pivot Table

Tabular Form (2)

This layout is a hierarchical structure, and each Row field is in a separate column in the pivot table. It can display subtotals at the top of every group because items in the next column are displayed in one row below the current item.

This traditional table format includes Field headers in each column. It allows you to repeat all the item labels and reuse the Pivot Table data in a new location for further analysis. As a disadvantage, this layout uses horizontal space, and subtotals can’t be shown at the top of the group.

JavaScript Pivot Table

Pivot Table Collapsing and Grouping

SpreadJS supports pivot table grouping and collapsing to view data more easily. Users can set the collapse info for a specified field of the pivot table by the field name using the collapse method.

Users can also group dates, numbers, and text fields. Please look below to see how to collapse a field and break down the different grouping and ungrouping techniques supported with SpreadJS by using the group and ungroup method.

Collapse

To collapse a field, use SpreadJS' collapse method and indicate the target field's name and the collapsed item's name. The example shows a variety of listening regions collapsed.

spread.suspendPaint();
    let isCollapse = false;
    if(e.target.checked){
        isCollapse = true;
    }
    pivotTable.collapse("region","Africa",isCollapse);
    pivotTable.collapse("region","Asia",isCollapse);
    pivotTable.collapse("region","Australia",isCollapse);
    pivotTable.collapse("region","Europe",isCollapse);
    pivotTable.collapse("region","North America",isCollapse);
    pivotTable.collapse("region","South America",isCollapse);
    spread.resumePaint();
});

Notice that when selected, all of the specified fields are collapsed–making the data easier to view:

JavaScript Collapse

Grouping Dates

When grouping dates with SpreadJS, users can indicate the DateGroupType by hours, days, quarters, years, and more. For example, if a user wants to group their dates by quarters and years, they could use dateGroups and initialize the new groupInfo like so:

let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }, { by: GC.Pivot.DateGroupType.years }] };
pivotTable.group(groupInfo);
pivotTable.add("Years", "Years", GC.Spread.Pivot.PivotTableFieldType.columnField);

When ungrouping date groups, all of the dates with the same origin field will be removed, and the origin field revert to the normal date.

Grouping Text

Users may want to group specific text items to differentiate from the rest of the data. To do this, the user can create a group of text values. When adding a text group, a new field will be created. The field's name is the fieldName given in groupInfo.textGroup. You can use the new field as a group field. This example shows a new group being added as a column field:

let groupInfo = { originFieldName: "country",textGroup: {
    fieldName:"country1",
    groupItems:{
        group1:["Spain","China","Australia","Egypt"],
        group2:["Germany","Republic of Korea","South Africa"]
    }
} };
pivotTable.group(groupInfo);
pivotTable.add("country1", "country1", GC.Spread.Pivot.PivotTableFieldType.columnField);

When ungrouping text groups, the field will be removed when ungrouped.

Grouping Numbers

Grouping numbers with SpreadJS will add a number group. The origin field specified in the groupInfo will be changed to the group field to use as such. Grouping numbers appear as follows:

let groupInfo = { originFieldName: "id",numberGroup: { by: 100 } };
pivotTable.group(groupInfo);

When ungrouping number groups, the field will revert to the normal number field.


Pivot Table Theme

The SpreadJS PivotTable provides 85 predefined themes - 29 light, 28 medium, and 28 dark.

You can apply the pivot table theme when adding the pivot table, or you can use the theme function.

let pivotTable = sheet.pivotTables.add("PivotTable", table.name(), 0, 0, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium2);
//pivotTable.theme(GC.Spread.Pivot.PivotTableThemes.dark2);
//pivotTable.theme("dark2");

Choosing the right theme improves the appearance of your pivot table and offers a more professional presentation of data for the end receivers of your report. See the online JavaScript Pivot Table Theme demo here.

JavaScript Pivot Table Themes


Pivot Styles

You can apply a pivot table style to highlight any specific data. The style method can apply styles to row, column, value, and label fields. For example, the following code snippet applies a style to the value fields.

// Get the pivot area
let labelPivotArea = {
    dataOnly: true,
    references: [{
      fieldName: "Values",
      items: ["Global_Sales", "NA_Sales"]
    }]
};
// Create style
let style = new GC.Spread.Sheets.Style();
style.backColor = "#82bc00";
// Set pivot style
pivotTable.setStyle(labelPivotArea, style);

This code will highlight the value fields “Global_Sales”, “JP_Sales”, and “NA_Sales”:

JavaScript Pivot Table

With this support, JavaScript developers can customize and apply their own rules, styles, and formatting to certain pivot table fields; check out SpreadJS’ online Pivot Style demo for more information.


Pivot Table AutofitColumn

SpreadJS’s pivot table offers an AutofitColumn function that adjusts the pivot table's column width to accommodate the longest value in a field. Overall, it is a helpful function and convenient when working with long, text-based fields.

// Auto fit Pivot Table columns
pivotTable.autoFitColumn();

The GIF below demonstrates this function; when the page reloads, the autoFitColumn function is invoked:

Autofit PivotTables in JavaScript using the autoFitColumn method


Pivot Table Slicers

Pivot Table Slicers are an interactive visual control that allows users to filter and manipulate data within a pivot table. They provide a user-friendly way to narrow down the data displayed in a pivot table by selecting specific criteria, such as dates, categories, or other relevant dimensions. Users can quickly analyze and explore data subsets using slicers without modifying the underlying pivot table structure. SpreadJS supports both the Item Slicer and Timeline Slicer.

PivotTable Item Slicer

Item Slicer

PivotTable Timeline Slicer

Timeline Slicer

Check out SpreadJS’ JavaScript Slicer demo to try the slicers for yourself.


Pivot ContextMenu

SpreadJS offers a Pivot ContextMenu that empowers users to perform various actions on pivot tables effortlessly. This feature allows users to sort data, rearrange field headers, and personalize the control by expanding or collapsing field values. The Pivot ContextMenu provides a user-friendly and compact interface to modify the appearance of pivot table data.

When interacting with different parts of a pivot table and then right-clicking, SpreadJS presents distinct context menu options. Here are some of the JavaScript Pivot Table Context Menus:

The page area

React Pivot Table

The header area

React Pivot Table

The data area

React Pivot Table

The Grand Total area

React Pivot Table

Users can also format values with given formats or customized ones by choosing the “Value Field Settings..." option from the data area or the Grand Total area context menu to open the dialog window.

Value Field Settings

Pivot Conditional Formatting

Conditional Formatting is a powerful tool that allows you to quickly highlight data fields, making it easier to identify outliers or refine your results. In a pivot area, you have the flexibility to apply, retrieve, and remove conditional formatting rules. These rules remain in effect even if you make changes to the PivotTable layout.

You can apply Conditional Formatting to the SpreadJS’s Pivot Table using the addConditionalRule method.

Check out SpreadJS’s online demo. This demo applies different color formatting depending on the cell values, with green being the lowest and red the highest.

Conditional Formatting in JavaScript Pivot Tables

JavaScript Pivot Table Benefits

Now that you have seen how SpreadJS can be used to add PivotTables to your application, we can go through some of the benefits of doing so:

Interactive Data Analysis

With a few lines of code or a couple of clicks in the Designer, a SpreadJS Pivot Table can reduce hours of work to only a few minutes. Decrease potential errors by manually creating calculated fields, groups, and filters–then let SpreadJS Pivot Tables do the rest. Focus more time on interpreting and analyzing data efficiently rather than manually creating your data breakdowns. You can use the pivot table panel to seamlessly drag-and-drop fields between the different areas and customize how the pivot table displays your data.

Interactive Data Analysis

Reviewing Product Sales

Reporting sales numbers can be daunting, especially with thousands of records, products, offices, and employees, and that's where SpreadJS Pivot Tables help. A pivot table can summarize a large amount of raw data in more understandable terms. For example, SpreadJS Pivot Tables would allow you to see the sales of a particular salesperson during a specific period of time. Easily report actual sales numbers against a target, analyze employee commission levels, and view reseller transactions.

You can instantly aggregate sales numbers by different fields and filters, giving you a clear and concise view of the data you need. In this case, you can import sales data for multiple stores, filter by promotions, and separate them into different sales channels to get a breakdown of your sales data.

Sales Pivot Table

FinTech

Create income statements, balance sheets, and profit and loss statements easily with SpreadJS Pivot Tables. You can also emphasize profit subtotals, including gross and operating subtotals. Create custom groupings that might not be available in your source data to provide the exact data breakdown you need. Include calculated fields to summarize large amounts of data in concise, customizable tables.

Financial Pivot Table

Marketing

With SpreadJS Pivot Tables, you can track your company's growth with various KPIs. You can also create a table focusing on multiple marketing strategies and inputs, including paid advertising campaigns, social media engagement, click-through, and conversion rates.

Visualize the analysis of advertising campaigns by geography, date ranges, and channels, and provide a breakdown of the results in an informative pivot table. For example, you could check product categories and see which categories customers purchase the most. Filter those orders by the corresponding promotion to help report on the promotion's effectiveness.

Marketing Pivot Table

Budgeting

SpreadJS Pivot Tables make creating budgets simple and straightforward. Create detailed pivot tables to compare budgets for the unique aspects of your business, such as tracking actual expenses compared to projected values. Summarize expenditures for different stores and product lines by months, categories, or any other fields with a simple interface–easily dragging and dropping fields to fit your requirements. Analyze and categorize the store spending and compare the year-over-year values.

Budget Pivot Table

Ready to Get Started? Download a free trial of SpreadJS today!

We hope you enjoyed learning how to create and customize JavaScript Spreadsheet Pivot Tables. This article only scratches the surface of the full capabilities of SpreadJS, the JavaScript spreadsheet component. Review the documentation to see some of the many available features, and check out our online demos to see the features in action and interact with the sample code.

Tags:

Skip to main content Skip to footer

How to Add a Vue Pivot Table to Your Web Application

  • 0 Comments
Quick Start Guide
Tutorial Concept

Learn how to integrate a Vue Spreadsheet component with Pivot Table functionality in Vue web applications.

What You Will Need
Controls Referenced

Documentation | Online Vue Pivot Table Demos

Pivot Tables are a powerful way to explore and summarize large datasets—perfect for breaking down complex info into clear, digestible insights. In this guide, we'll walk through how to integrate a Pivot Table directly into your Vue application using the Vue Spreadsheet component, SpreadJS, and its optional Pivot Table add-on. Instead of bland generic data, we'll work with a fun mock dataset based on video games, featuring fields like title, genre, platform, pricing, and ratings to simulate a real-world use case.

Download a free trial of SpreadJS today!

Create and Customize Vue Pivot Tables

Customizing Pivot Tables and Reports with a Vue Spreadsheet Pivot Table API

You can download a sample application here to follow along with the blog.

Create a Vue Pivot Table

To get started, we have a Vue spreadsheet app that uses SpreadJS with countless rows of data containing specific information. For this example, in the datasheet below, we have a large number of records showing the best-selling video games.

Vue Spreadsheet Application

To follow along, make sure your project includes the required NPM packages:

npm install @mescius/spread-sheets
npm install @mescius/spread-sheets-vue
npm install @mescius/spread-sheets-pivot-addon
npm install @mescius/spread-sheets-shapes

Import and globally register the gc-spread-sheets, gc-worksheet, and gc-column components from @mescius/spread-sheets-vue in the main.js file so they can be used throughout your Vue 3 app.

import "./assets/main.css";
import { createApp } from "vue";
import App from "./App.vue";
import { GcSpreadSheets, GcWorksheet, GcColumn, } from "@mescius/spread-sheets-vue"; 

let app = createApp(App);
app.component("gc-spread-sheets", GcSpreadSheets);
app.component("gc-worksheet", GcWorksheet);
app.component("gc-column", GcColumn);
app.mount("#app");

In the App.vue file, use the add method from the PivotTableManager to create a Pivot Table, referencing your source table by name:

const pivotTable = sheet.pivotTables.add(pivotTableName, tableDataSource, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.tabular, GC.Spread.Pivot.PivotTableThemes.medium14, pivotTableOptions);

Developers can programmatically set the pivot table fields using the Add method and invoking the autoFitColumn from the PivotTable class after resuming the layout to adjust the column widths:

pivotTable.suspendLayout();
pivotTable.add("platform", "Platform", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("genre", "Genre", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("sales", "Sales", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.add("price", "Price", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.average);
pivotTable.resumeLayout();
pivotTable.autoFitColumn();

The new Vue Pivot Table data will now display in the application as below:

Vue Pivot Table Example - AutoFit Applied, No Formatting

To improve readability, let's format the value fields, Price and Sales, by applying a currency style using the setStyle method.

// Create formatter style
const currencyStyle = new GC.Spread.Sheets.Style();
currencyStyle.formatter = '$ #,##0.00';
const largeCurrencyStyle = new GC.Spread.Sheets.Style();
currencyStyle.formatter = '$ #,##.00';
// Utility to get field area reference
const initArea = (fieldName, pt) => ({
     dataOnly: true,
     references: [{ fieldName: 'Values', items: [fieldName] }]
})
// Apply currency format to Price and Sales
const priceArea = initArea('Price', pivotTable);
const salesArea = initArea('Sales', pivotTable);
if (priceArea) pivotTable.setStyle(priceArea, currencyStyle);
if (salesArea) pivotTable.setStyle(salesArea, currencyStyle);

With just a few lines of code, you have a fully interactive Pivot Table in your Vue app. Next, we'll show you how to customize it further—from layout and theme options to Pivot Panels, slicers, and more.

Vue Pivot Table Spreadsheet - Formatting applied

For more information on getting started with Vue Pivot Tables, check out our documentation or online Vue Pivot Table demo.


Add Pivot Table Panels to Vue App

Another way to allow users to create or analyze Pivot Table data in your Vue app is to use the customizable Pivot Panel offered by SpreadJS.

To initialize the Pivot Panel in a Vue app, first, create a DOM element—in this case, a DIV with an ID "panel":

<template>
  <div class="sample-tutorial">
    <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread" />
  </div>
  <div class="sample-panel">
    <div id="panel"></div>
  </div>
</template>

Apply CSS for the side panel. Interesting side note—developers can customize the styling and appearance of the Pivot Panel here through the CSS:

.sample-panel {
  float: right;
  width: 300px;
  padding: 12px;
  height: 100%;
  box-sizing: border-box;
  background: #fbfbfb;
  overflow: auto;
}

.gc-panel {
  padding: 10px;
  background-color: rgb(230, 230, 230);
}

#panel {
  position: absolute;
  right: 0;
  width: 300px;
  height: 100%;
  top: 0;
}

Then, use the PivotPanel constructor to initialize the Pivot Panel for the created Pivot Table.

var panel = new GC.Spread.Pivot.PivotPanel("myPivotPanel", pivotTable, document.getElementById("panel"));

The application will now display the Vue Pivot Table with the Pivot Panel, allowing end-users to drag and drop the needed fields according to the report logic.

Vue Pivot Table Panels

To learn more about the Vue Spreadsheet Pivot Table Panels, check out the documentation and online demo.


Set the Vue Pivot Layout

SpreadJS allows you to choose from three different pivot table layouts to offer different visualizations of your data. This includes the Compact, Outline, and Tabular form layouts. By default, the pivot table layout is Compact form. Still, users can set the layout when creating the pivot table using the PivotTable constructor or change the layout using the layoutType function. The function has an integer argument corresponding to the form layout (0 - compact, 1 - outline, 2 - tabular).

// Set an outline form (1) 
pivotTable.layoutType(1);
Compact Form (0) All row fields appear in a single column, nested in a hierarchy. Saves space, but harder to reuse or copy data. Vue Spreadsheet Example - Compact Form
Outline Form (1) Row fields appear in separate columns with field headers. Easier to analyze and reuse, but uses more horizontal space. Vue Spreadsheet Example - Outline Form
Tabular Form (2) Similar to Outline, with repeated item labels. Ideal for exports. Subtotals only appear below groups. Vue Spreadsheet Example - Tabular Form

To learn more, check out SpreadJS' online PivotTable Layout demo and documentation.


Pivot Table Theme

Choosing the right theme improves the appearance of your pivot table and offers a more professional presentation of data for your reports' end receivers. The SpreadJS Vue PivotTable provides 85 predefined themes—29 light, 28 medium, and 28 dark.

You can apply the pivot table theme when adding a Pivot Table, or you can use the theme function.

let pivotTable = sheet.pivotTables.add("PivotTable", table.name(), 0, 0, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium2); 
//pivotTable.theme(GC.Spread.Pivot.PivotTableThemes.dark2); 
//pivotTable.theme("dark2");

Set Pivot Table Themes in Vue3 Apps

To learn more, check out SpreadJS' documentation or the online Pivot Table Theme demo.


Pivot Table Slicers

Pivot Table Slicers are interactive visual controls that allow users to filter and manipulate data within a pivot table. They provide a user-friendly way to narrow down the data displayed in a pivot table by selecting specific criteria, such as dates, categories, or other relevant dimensions. Using slicers, users can quickly analyze and explore data subsets without modifying the underlying pivot table structure. SpreadJS supports both the Item Slicer and Timeline Slicer.

PivotTable Item Slicer PivotTable Timeline Slicer
Pivot Table Item Slicer Example Pivot Table Timeline Slicers Example

Check out our Vue3 Pivot Table Slicer demo or the documentation to learn more.


Pivot ContextMenu

SpreadJS offers a Pivot ContextMenu that empowers users to perform various actions on pivot tables effortlessly. This feature allows users to sort data, rearrange field headers, and personalize the control by expanding or collapsing field values. The Pivot ContextMenu provides a user-friendly and compact interface to modify the appearance of pivot table data.

When interacting with different parts of a pivot table and then right-clicking, SpreadJS presents distinct context menu options. Below are some of the Vue Pivot Table Context Menus:

Pivot Table Context Menus in Vue Application

Users can also format values with given or customized formats by choosing the "Value Field Settings..." option from the data area or the Grand Total area context menu to open the dialog window.

Format Values in Pivot Tables - Vue Dialog Box

Try the Pivot Table Context Menus yourself with our online Vue3 demo, or learn more from our documentation.


Pivot Conditional Formatting

Conditional Formatting helps highlight patterns and outliers in your Pivot Table. In SpreadJS, rules can be added, retrieved, or removed, and they stay active even when the layout changes.

Use the addConditionalRule method to apply conditional formatting based on cell values. In the example below, green represents low values and red represents high values.

Apply Conditional Formatting to a Vue3 Pivot Table Component

Try this demo by visiting the SpreadJS Pivot Table Conditional Formatting Vue demo explorer.


Vue Pivot Table Component

We hope you enjoyed learning how to create and customize Vue Spreadsheets Pivot Tables using SpreadJS and its optional Pivot Table add-on. You can download the sample application for this blog to try it yourself. This article only scratches the surface of the full capabilities of SpreadJS, the Vue spreadsheet component.

Review the documentation to see some of the many available features, and check out our online demos to see the features in action and interact with the sample code. Integrating a spreadsheet component into your Vue applications allows you to customize your users' experience and provide them with familiar spreadsheet functionality.

Tags:

How to Add a React Pivot Table to Your Web Application

Data tables and grids have become staples in modern UI design. They allow our users to easily view large data sets, compare values, and make decisions based on empirical data. However, sometimes the data sets that we’re working with aren’t easily viewable in a standard table, or there may be instances where we want certain data excluded to make it easier to see correlations between data points. Thankfully, software engineers and computer programmers have developed a more advanced form of a data table that allows us to do just that: pivot tables.

A pivot table is a data table that aids users in tasks such as data discovery; it allows users to perform complex analytical calculations on the data set that you’ve loaded, determine what data you want to display, and determine the orientation of the data. This allows users to see trends that may normally be missed if you’re using a traditional data table.

Luckily, Wijmo has you covered with PivotGrid, the best React pivot table control available. It's simple to implement, easy to customize, and even has an extensive list of features that allow you to easily integrate it into your application.

In this article, we’ll be outlining how to do the following using Wijmo’s React pivot table, PivotGrid:

If you’d like to download the finished project to aid you in following along, you can find the source code for the application here. Now, let’s get to work!

If you’d like to try out Wijmo, you can download the entire UI component library, available in pure JavaScript, Angular, React, and Vue, here.

Loading Data with the Pivot Engine

Before we get into implementing Wijmo’s React pivot table, PivotGrid, we’ll need to load all of the required resources into the React application. The first thing that we’ll need to do is install the Wijmo UI component library, which we’ll do via NPM. Inside your React application, run the following command:

npm i @grapecity/wijmo.react.all

This will install the Wijmo library in your application. You may have noticed that we specify a react package in the installation path; Wijmo supports Angular, React, and Vue along with its core JavaScript library, so we’re specifying the react package so that we don’t install any unnecessary files.

Next, we’ll need to include Wijmo’s CSS file, as well as import the correct Wijmo modules into our application. Open up the App.js file and include the following:

import './App.css';
import '@grapecity/wijmo.styles/wijmo.css';

import * as wjOlap from '@grapecity/wijmo.olap';
import * as wjcOlap from '@grapecity/wijmo.react.olap';

import { useState } from 'react';

function App() {...}

export default App;

Great! We’ve included all of the relevant Wijmo files we’ll need. One final thing that we’ll do is generate some data, which we’ll use to populate the PivotGrid. Inside the src folder, create a new file called data.js and add the following code to the file:

var products = [
    { product: 'Wijmo', platform: 'Web' },
    { product: 'ActiveReports', platform: 'Desktop' },
    { product: 'ActiveReportsJS', platform: 'Web' },
    { product: 'ComponentOne', platform: 'Desktop' },
    { product: 'Spread', platform: 'Desktop' },
    { product: 'SpreadJS', platform: 'Web' },
    { product: 'GCDocs', platform: 'Desktop' }
];

var agents = [
    { agent: 'Ashlyn Dunlop', region: 'East' },
    { agent: 'Keith Vang', region: 'East' },
    { agent: 'Bobbi Rodrigues', region: 'West' },
    { agent: 'Charli Medina', region: 'West' },
    { agent: 'Kaitlin Salt', region: 'West' },
];

function randomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1) + min);
}

export function getOrderList(count) {
    var year = new Date().getFullYear(), data = [];
    for(var i = 0; i < count; i++) {
      let productIdx = randomInt(0, 6);
      let agentIdx = randomInt(0, 4);
      data.push({
        orderId: randomInt(1, 10000),
        platform: products[productIdx].platform,
        product: products[productIdx].product,
        agent: agents[agentIdx].agent,
        region: agents[agentIdx].region,
        date: new Date(year - randomInt(0, 2), randomInt(0, 11), randomInt(0, 27)),
        sales: randomInt(10, 50),
        downloads: randomInt(10, 200),
        revenue: randomInt(500, 3500)
      });
    }
    return data;
}

The data here isn’t really relevant; it's just mock data for the purposes of showing the functionality of the components, so I’m not going to spend much time on it. What’s important to know is that we’ve got a large set of data, which will be used to populate the components.

Now with the application set up, we can finally get into implementing Wijmo’s React pivot table, PivotGrid.

Open up your application’s App.js file and add the following code:

import './App.css';
import '@grapecity/wijmo.styles/wijmo.css';
import { getOrderList } from './data';

import * as wjOlap from '@grapecity/wijmo.olap';
import * as wjcOlap from '@grapecity/wijmo.react.olap';

import { useState } from 'react';

function App() {
  const [ng, setNG] = useState(new wjOlap.PivotEngine({
    itemsSource: getOrderList(1000)
  }));
  return (...);
}

export default App;

As you can see, it's only a few lines of code. But we must explain what’s going on here. In the file, we’re initializing a Wijmo component called PivotEngine. The PivotEngine handles the management of the data, and without the PivotEngine, Wijmo’s PivotGrid and PivotPanel controls wouldn’t be able to function. You can think of the PivotEngine as the foundation of our pivot table; without it, the table would have no data to display to the users.

Along with initializing the Wijmo component, we’re also setting its itemsSource property. This tells the engine, “Hey, this is the data that we want you to manage.” In the case of this application, we’re calling the getOrdersList() function from our service, which will return 1000 rows of data to load.

Now that we’ve got the PivotEngine loaded with data, it’s time to display it on-screen.

Setting Up the PivotPanel and PivotGrid

Now that the PivotEngine has been set up, it's time to use it. As we mentioned in the last section, the engine manages our data. So, for users to interact with the data, we need to connect it to our UI elements: the PivotPanel and PivotGrid.

We’ve previously mentioned Wijmo’s PivotGrid, but we haven’t talked much about the PivotPanel. The PivotPanel is how users interact directly with the data being displayed. This includes determining what data fields are column, row, filter, and value fields, as well as access to the Field Settings menu to customize the data of the selected field further.

Instead of any further explanation, it would be better to show you what you can do with the PivotPanel and PivotGrid. To add these to your application, open up the App.js file and add the following code:

function App() {
  const [ng, setNG] = useState(new wjOlap.PivotEngine({
    itemsSource: getOrderList(1000)
  }));
  return (
    <div className="App">
      <div className='flextable'>
        <wjcOlap.PivotPanel itemsSource={ng}></wjcOlap.PivotPanel>
        <wjcOlap.PivotGrid itemsSource={ng}></wjcOlap.PivotGrid>
      </div>
    </div>
  );
}

And that’s all it takes! It really is that easy to implement Wijmo’s React pivot table. Like with the PivotEngine, the PivotGrid and PivotPanel both need to be supplied with an itemsSource. Unlike the PivotEngine, however, these components don’t take a simple array; they take a PivotEngine! So, using the ng variable that we set up in the previous section, we can assign that as the itemsSource for both components.

Before running the application, we want to add a little style to clean up the layout. Open up the App.css file and add the following:

.App {
  margin: 30px;
}

.flextable {
    display: flex;
}

.wj-pivotpanel {
    width: 500px;
    margin: 0px 10px;
}

Open up the index.css file and add the following code:

.wj-pivotpanel {
  width: 500px !important;
  margin: 0px 10px !important;
}

.wj-pivotgrid {
  height: 600px !important;
}

We’re setting up the application so that the PivotPanel and PivotGrid display side-by-side, as well as setting the width of the PivotPanel so that it makes more room for the PivotGrid.

Now, if you run the application, you should see the following:

As you can see, nothing is loaded into the PivotGrid; that’s to be expected. Nothing will display unless we set some fields in the PivotPanel. Let’s fix that and add a couple of fields:

As you can see via the PivotPanel, we’ve added the following fields to the various areas of the panel:

Column Fields

Row Fields

Value Fields

Platform

Region

Sales

Product

Agent

Downloads

 

 

Revenue

Now, we can see a breakdown of all sales metrics across regions, by agents, and even by product and platform.

One final thing to discuss before moving on is the Field Settings menu. This menu can be accessed by right-clicking any of the cells in the PivotGrid, or by right-clicking any of the field names in the PivotPanel:

Selecting the Field Settings… option will open up the Field Settings modal:

Here, we can change how the data is summarized, add calculations (such as % difference from the previous row), add filters, and even format how the data is displayed, which includes a preview based on the selected format.

Since this is the field settings menu for the Sales field, we’re just going to change the format to display in a currency format instead of a basic integer format:

As you can see, it also shows us a preview of the updated format. If we click the OK button, we should see the following:

As you can see, the Sales columns are now all displaying in a currency format instead of an integer format.

Creating Custom Fields

Now that we’ve implemented the PivotPanel and PivotGrid, as well as gone over the basics of using them, it’s time to customize our data using the PivotEngine. We can do this by setting up properties manually via the PivotEngine, instead of allowing it to generate them automatically.

Open up the App.js file and add the following:

function App() {
  const [ng, setNG] = useState(new wjOlap.PivotEngine({
    itemsSource: getOrderList(1000),
    fields: [
      { binding: 'date', header: 'Quarter', format: '\"Q\"q yyyy' },
      { binding: 'date', header: 'Month', format: 'MMMM' },
      { binding: 'agent', header: 'Agent' },
      { binding: 'region', header: 'Region' },
      { binding: 'platform', header: 'Platform' },
      { binding: 'product', header: 'Product' },
      { binding: 'sales', header: 'Sales', format: 'c2' },
      { binding: 'downloads', header: 'Downloads', format: 'n0' },
      { binding: 'revenue', header: 'Revenue', format: 'c2' },
    ]
  }));
  return (
    <div className="App">
      <div className='flextable'>
        <wjcOlap.PivotPanel itemsSource={ng}></wjcOlap.PivotPanel>
        <wjcOlap.PivotGrid itemsSource={ng}></wjcOlap.PivotGrid>
      </div>
    </div>
  );
}

As you can see, the fields property takes an array of objects, which is used to create the various fields that users can pick from in the PivotPanel. By default, these objects only need to have two properties: a binding and a header property. The binding property tells the engine which property name this field will be bound to. For Agent, Region, Platform, and Product, these are the only properties that we’re setting.

However, there’s another property that we can set: the format property. Like how users can use the Field Settings menu to change the formatting, developers can set the default format in which we want to display the field.

Along with setting the format, we can actually create multiple fields from the same data point and set different formats for both. In this application, we’re setting up quarterly and monthly date fields. Now, if we save this and open up the application, we’ll select a few fields, and you should see the following:

As you can see, we’ve created a quarterly and monthly field using a single data point. Now, users can view an even greater breakdown, seeing sales data breakdowns by quarterly and monthly views.

Using PivotCharts to Display Data in Chart Form

Along with Wijmo’s React pivot table, PivotGrid, Wijmo also offers a PivotChart control to work in conjunction with the PivotPanel and the PivotGrid. Like the PivotGrid, the PivotChart will automatically update to reflect changes in areas of the PivotPanel.

Adding a PivotChart is just as simple as adding the PivotGrid and PivotPanel. Open up your App.js file and modify the return() method as follows:

return (
  <div className="App">
    <div className='flextable'>
      <wjcOlap.PivotPanel itemsSource={ng}></wjcOlap.PivotPanel>
      <wjcOlap.PivotGrid itemsSource={ng}></wjcOlap.PivotGrid>
    </div>
    <wjcOlap.PivotChart itemsSource={ng} showTitle={false} showLegend={'Auto'}></wjcOlap.PivotChart>
  </div>
);

And that’s it! We pass the PivotEngine in as the itemsSource for the PivotChart. Now, if you save the application and reload it, if you add any fields to the Value area, you’ll see them reflected in the PivotChart. Take a look at the image below:

As you can see, we’ve set the Quarter and Platform fields as row fields, and then the Sales and Downloads fields as value fields. The PivotChart then shows a breakdown, similar to how the PivotGrid does, of the data we’ve selected inside the PivotPanel.

Conclusion

And with that, we’ve come to the end. In this article, we’ve gone over some of the benefits of using React pivot tables and how you can use Wijmo to implement your own pivot table, pivot chart, and pivot panel to manage the data.

If you’d like to try out Wijmo, you can download the entire UI component library, available in pure JavaScript, Angular, React, and Vue, here.

Happy coding!

 

Tags:

comments powered by Disqus